﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        const int n = 50;
        public Window1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int[] data = setdata(n);
            quicksort(0, n - 1, ref data);
            printdata(data);
        }

        int[] setdata(int n)
        {
            int[] data = new int[n];
            Random R = new Random();
            for (int i = 0; i < n; i++)
            {
                data[i] = i;

            }

            for (int i = 0; i < n; i++)
            {
                swap(ref data[i], ref data[R.Next(n - 1)]);
            }
            return data;
        }
        void swap(ref int a, ref int b)
        {
            int t = b;
            b = a;
            a = t;
        }
        void quicksort(int start, int finish, ref int[] data)
        {
            if (start >= finish) return;
            int L = start;
            int R = finish;
            int pivot = data[start + (finish - start) / 2];
            scan(ref L, ref R, pivot, data);
            while (L != R)
            {
                swap(ref data[L], ref data[R]);
                if (data[L] == pivot && data[R] == pivot) L++;
                scan(ref L, ref R, pivot, data);
            }
            quicksort(start, L - 1, ref data);
            quicksort(R + 1, finish, ref data);
        }

        void scan(ref int L, ref int R, int pivot, int[] data)
        {
            while (data[L] < pivot)
            {
                L++;
                if (L == R) return;
            }
            while (data[R] > pivot)
            {
                R--;
                if (L == R) return;
            }
        }
        void printdata(int[] data)
        {
            for (int i = 0; i < n; i++)
            {
                Console.WriteLine(data[i].ToString());
            }
        }
    }

}
